////////////////////////////////////////////////////////////////
// 目覚し時計ガジェット
//   Copyright (C) 2008 - 2012 AAOh inc.
////////////////////////////////////////////////////////////////

/**
 * @fileOverview 目覚し時計ガジェット
 * @author       $Author: fujishiro $
 */

(function () {
/**
 * Main。
 *
 * @constructor
 */
aclock.Main = aaoh.kaze.Gadget.extend(
	aaoh.sora.MainEx, function() {
	this.CLOCK_INTERVAL     = 1000;           // msec
	this.ALARM_OFF_TIMEOUT  = 20 * 60 * 1000; // msec
	this.SNOOZE_ON_INTERVAL =  5 * 60 * 1000; // msec
	this.SNOOZE_OFF_TIMEOUT =  3 * 60 * 1000; // msec
	this.ALARM_SET_INTERVAL = 200;            // msec

	// 時計
	this.clockTimer  = new aaoh.kaze.Timer(this);
	this.cvsClock    = aaoh.kaze.Gadget.$('cvsClock');
	this.ctxClock    = null;
	this.alarmAngle  = 0;
	this.flgAlarmImg = false;

	this.imgAlarm    = null;
	this.imgHour     = null;
	this.imgMin      = null;
	this.imgSec      = null;
	this.alarmAlarm  = null;
	this.alarmHour   = null;
	this.alarmMin    = null;
	this.alarmSec    = null;
	this.imgAlarmObj = null;
	this.imgHourObj  = null;
	this.imgMinObj   = null;
	this.imgSecObj   = null;

	if (this.cvsClock != null) {
		if (!this.cvsClock.getContext) {
			// IE対応
			this.cvsClock = G_vmlCanvasManager.initElement(this.cvsClock);
		}
		this.ctxClock    = this.cvsClock.getContext('2d');
		this.imgAlarm    = new Image();
		this.imgHour     = new Image();
		this.imgMin      = new Image();
		this.imgSec      = new Image();
		this.alarmAlarm  = new Image();
		this.alarmHour   = new Image();
		this.alarmMin    = new Image();
		this.alarmSec    = new Image();

	} else {
		this.imgAlarmObj = aaoh.kaze.Gadget.$('imgAlarm');
		this.imgHourObj  = aaoh.kaze.Gadget.$('imgHour');
		this.imgMinObj   = aaoh.kaze.Gadget.$('imgMin');
		this.imgSecObj   = aaoh.kaze.Gadget.$('imgSec');
	} // if (this.cvsClock != null)

	// アラーム
	this.alarmRepeatTimer  = new aaoh.kaze.Timer(this);
	this.alarmOnTimer      = new aaoh.kaze.Timer(this);
	this.alarmOffTimer     = new aaoh.kaze.Timer(this);
	this.snoozeOnTimer     = new aaoh.kaze.Timer(this);
	this.snoozeOffTimer    = new aaoh.kaze.Timer(this);
	this.alarmRepeatFile   = null;
	this.tipAlarmOn        = null;
	this.tipAlarmOff       = null;
	this.tipAlarmStart     = null;
	this.tipSnoozeOn       = null;
	this.tipSnoozeOff      = null;

	this.srcAlarmOnUp      = null;
	this.srcAlarmOnOver    = null;
	this.srcAlarmOnDown    = null;
	this.srcAlarmOffUp     = null;
	this.srcAlarmOffOver   = null;
	this.srcAlarmOffDown   = null;
	this.srcAlarmStartUp   = null;
	this.srcAlarmStartOver = null;
	this.srcAlarmStartDown = null;
	this.srcSnoozeOnUp     = null;
	this.srcSnoozeOnOver   = null;
	this.srcSnoozeOnDown   = null;
	this.srcSnoozeOffUp    = null;
	this.srcSnoozeOffOver  = null;
	this.srcSnoozeOffDown  = null;

	// アラーム設定
	this.alarmSetHourTimer = new aaoh.kaze.Timer(this);
	this.alarmSetMinTimer  = new aaoh.kaze.Timer(this);
	this.alarmSetSecTimer  = new aaoh.kaze.Timer(this);
	this.isAlarmSetHourAdd = true;
	this.isAlarmSetMinAdd  = true;
	this.isAlarmSetSecAdd  = true;

	this.main      = aaoh.kaze.Gadget.$('main');
	this.imgPin    = aaoh.kaze.Gadget.$('imgPin');
	this.btnMode   = aaoh.kaze.Gadget.$('btnMode');
	this.btnSet    = aaoh.kaze.Gadget.$('btnSet');
	this.dispTimer = new aaoh.kaze.Timer(this);
	this.optTimer  = new aaoh.kaze.Timer(this);

	this.optFadeinAni  = null;
	this.optFadeoutAni = null;
	if (!aaoh.kaze.Type.isIE()) {
		var optAlarmSet = aaoh.kaze.Gadget.$('optAlarmSet');
		this.optFadeinAni
			= new aaoh.kaze.animation.FadeinAnimation(optAlarmSet);
		this.optFadeoutAni
			= new aaoh.kaze.animation.FadeoutAnimation(optAlarmSet);
		this.optFadeoutAni.startCallable = function(element, startValue) {
			aaoh.kaze.Element.setDisplay(element, true);
			aaoh.kaze.Element.setOpacity(element, startValue);
		}
		this.optFadeoutAni.stopCallable = function(element, stopValue) {
			aaoh.kaze.Element.setDisplay(element, false);
			aaoh.kaze.Element.setOpacity(element, stopValue);
		}
	}
});
	/**
	 * 時計の設定。
	 */
	aclock.Main.prototype.
	setClock = function() {
		var date = new Date();
		var numHour = date.getHours();
		var numMin  = date.getMinutes();
		var numSec  = date.getSeconds();

		// 角度の算出
		var angleHour = ((numHour % 12) + numMin / 60) * (360 / 12);
		var angleMin  = (numMin + numSec / 60) * (360 / 60);
		var angleSec  = numSec * (360 / 60);

		// 描画イメージの設定
		var imgList = this.getDrawImages(false);
		var alarm   = imgList[0];
		var hour    = imgList[1];
		var min     = imgList[2];
		var sec     = imgList[3];

		// 時計の描画
		if (this.cvsClock != null) {
			this.ctxClock.clearRect(
				0, 0, this.cvsClock.width, this.cvsClock.height
			);

			// キャンバスの描画
			this.drawCanvas(hour, angleHour);
			this.drawCanvas(min,  angleMin);
			if (aaoh.sora.App.model.data.isDispSec) {
				this.drawCanvas(sec, angleSec);
			}
			if (
				aaoh.sora.App.model.data.alarmMode
					!= aaoh.sora.App.control.MODE_ALARM_OFF
			) {
				this.drawCanvas(alarm, this.alarmAngle);
			}

		} else {
			// 画像の回転
			//if (
			//	aaoh.sora.App.model.data.alarmMode
			//		!= aaoh.sora.App.control.MODE_ALARM_OFF
			//) {
			//	this.rotateImage(alarm, this.alarmAngle);
			//}
			this.rotateImage(hour, angleHour);
			this.rotateImage(min,  angleMin);
			if (aaoh.sora.App.model.data.isDispSec) {
				this.rotateImage(sec, angleSec);
			}
		} // if (this.cvsClock != null)

		// ツールチップの設定
		var hourValue = numHour.toString();
		var minValue  = numMin.toString();
		var secValue  = numSec.toString();
		if (hourValue.length <= 1) {
			hourValue = '0' + hourValue;
		}
		if (minValue.length <= 1) {
			minValue = '0' + minValue;
		}
		if (secValue.length <= 1) {
			secValue = '0' + secValue;
		}

		var tooltipValue = hourValue + ':' + minValue + ':' + secValue;
		if (this.cvsClock != null) {
			aaoh.kaze.Element.setTooltip(this.cvsClock, tooltipValue);

		} else {
			//aaoh.kaze.Element.setTooltip(this.main, tooltipValue);
			aaoh.kaze.Element.setTooltip(this.imgAlarmObj, tooltipValue);
			aaoh.kaze.Element.setTooltip(this.imgHourObj,  tooltipValue);
			aaoh.kaze.Element.setTooltip(this.imgMinObj,   tooltipValue);
			aaoh.kaze.Element.setTooltip(this.imgSecObj,   tooltipValue);
			aaoh.kaze.Element.setTooltip(this.imgPin,      tooltipValue);
		}
	}

	/**
	 * 描画イメージの取得。
	 *
	 * @param  {Bool}  flgOff アラームOffフラグ
	 * @return {Array}        描画イメージリスト
	 */
	aclock.Main.prototype.
	getDrawImages = function(flgOff) {
		var imgList = new Array();

		if (
			aaoh.sora.App.model.data.alarmMode
				!= aaoh.sora.App.control.MODE_ALARM_START
			&& aaoh.sora.App.model.data.alarmMode
				!= aaoh.sora.App.control.MODE_SNOOZE_ON
			&& !flgOff
		) {
			// 通常
			if (this.cvsClock != null) {
				imgList.push(this.imgAlarm);
				imgList.push(this.imgHour);
				imgList.push(this.imgMin);
				imgList.push(this.imgSec);

			} else {
				imgList.push(this.imgAlarmObj);
				imgList.push(this.imgHourObj);
				imgList.push(this.imgMinObj);
				imgList.push(this.imgSecObj);
			}

			return imgList;
		}

		// アラーム中
		if (this.cvsClock != null) {
			if (this.flgAlarmImg) {
				imgList.push(this.alarmAlarm);
				imgList.push(this.alarmHour);
				imgList.push(this.alarmMin);
				imgList.push(this.alarmSec);

			} else {
				imgList.push(this.imgAlarm);
				imgList.push(this.imgHour);
				imgList.push(this.imgMin);
				imgList.push(this.imgSec);
			}

		} else {
			var srcAlarm = null;
			var srcHour  = null;
			var srcMin   = null;
			var srcSec   = null;
			if (this.flgAlarmImg) {
				srcAlarm = this.alarmAlarm;
				srcHour  = this.alarmHour;
				srcMin   = this.alarmMin;
				srcSec   = this.alarmSec;

			} else {
				srcAlarm = this.imgAlarm;
				srcHour  = this.imgHour;
				srcMin   = this.imgMin;
				srcSec   = this.imgSec;
			}
			aaoh.kaze.Element.setImage(this.imgAlarmObj, srcAlarm);
			aaoh.kaze.Element.setImage(this.imgHourObj,  srcHour);
			aaoh.kaze.Element.setImage(this.imgMinObj,   srcMin);
			aaoh.kaze.Element.setImage(this.imgSecObj,   srcSec);

			imgList.push(this.imgAlarmObj);
			imgList.push(this.imgHourObj);
			imgList.push(this.imgMinObj);
			imgList.push(this.imgSecObj);
		} // if (this.cvsClock != null)

		// 描画イメージの設定
		this.showDrawImages();

		if (!flgOff) {
			if (this.flgAlarmImg) {
				this.flgAlarmImg = false;

			} else {
				this.flgAlarmImg = true;
			}
		}

		return imgList;
	}

	/**
	 * 描画イメージの設定。
	 */
	aclock.Main.prototype.
	showDrawImages = function() {
		var type        = aaoh.sora.App.model.data.type;
		var srcMain     = null;
		var srcPin      = null;
		var imgModeUp   = null;
		var imgModeOver = null;
		var imgModeDown = null;
		var tipMode     = null;
		var srcSetUp    = null;
		var srcSetOver  = null;
		var srcSetDown  = null;

		if (this.flgAlarmImg) {
			if (aaoh.kaze.Type.isSidebar()) {
				srcMain = 'lib/aaoh.sora.t.png';

			} else {
				srcMain = 'images/aclock0-base.png';
			}
			srcPin  = 'images/aclock0-pin.png';

			if (!aaoh.kaze.Type.isGoogle() && !aaoh.kaze.Type.isIE()) {
				imgModeUp = 'images/aclock0-start.png';
				srcSetUp  = 'images/aclock0-set.png';

			} else {
				imgModeUp   = 'sub-images/aclock0-start_up.png';
				imgModeOver = 'sub-images/aclock0-start_over.png';
				imgModeDown = 'sub-images/aclock0-start_down.png';
				srcSetUp    = 'sub-images/aclock0-set_up.png';
				srcSetOver  = 'sub-images/aclock0-set_over.png';
				srcSetDown  = 'sub-images/aclock0-set_down.png';
			}

		} else {
			if (aaoh.kaze.Type.isSidebar()) {
				srcMain = 'lib/aaoh.sora.t.png';

			} else {
				srcMain = 'images/aclock' + type + '-base.png';
			}
			srcPin  = 'images/aclock' + type + '-pin.png';

			switch (aaoh.sora.App.model.data.alarmMode) {
				// alarm on
				case aaoh.sora.App.control.MODE_ALARM_ON:
					imgModeUp   = this.srcAlarmOnUp;
					imgModeOver = this.srcAlarmOnOver;
					imgModeDown = this.srcAlarmOnDown;
					break;

				// alarm off
				case aaoh.sora.App.control.MODE_ALARM_OFF:
				default:
					imgModeUp   = this.srcAlarmOffUp;
					imgModeOver = this.srcAlarmOffOver;
					imgModeDown = this.srcAlarmOffDown;
					break;

				// alarm start
				case aaoh.sora.App.control.MODE_ALARM_START:
					imgModeUp   = this.srcAlarmStartUp;
					imgModeOver = this.srcAlarmStartOver;
					imgModeDown = this.srcAlarmStartDown;
					break;

				// snooze on
				case aaoh.sora.App.control.MODE_SNOOZE_ON:
					imgModeUp   = this.srcSnoozeOnUp;
					imgModeOver = this.srcSnoozeOnOver;
					imgModeDown = this.srcSnoozeOnDown;
					break;

				// snooze off
				case aaoh.sora.App.control.MODE_SNOOZE_OFF:
					imgModeUp   = this.srcSnoozeOffUp;
					imgModeOver = this.srcSnoozeOffOver;
					imgModeDown = this.srcSnoozeOffDown;
					break;
			} // switch (aaoh.sora.App.model.data.alarmMode)

			if (!aaoh.kaze.Type.isGoogle() && !aaoh.kaze.Type.isIE()) {
				srcSetUp   = 'images/aclock' + type + '-set.png';

			} else {
				srcSetUp   = 'sub-images/aclock' + type + '-set_up.png';
				srcSetOver = 'sub-images/aclock' + type + '-set_over.png';
				srcSetDown = 'sub-images/aclock' + type + '-set_down.png';
			}
		} // if (this.flgAlarmImg)

		if (imgModeUp == null) {
			return;
		}

		aaoh.kaze.Element.setBackgroundImage(this.main, srcMain, false);
		aaoh.kaze.Element.setImage(this.imgPin, srcPin);
		aaoh.kaze.Element.setBackgroundImage(
			this.btnMode, imgModeUp, imgModeOver, imgModeDown
		);
		aaoh.kaze.Element.setBackgroundImage(
			this.btnSet, srcSetUp, srcSetOver, srcSetDown
		);

		if (aaoh.kaze.Type.isSidebar()) {
			// 透過PNG対応
			var sidebarImgBg = aaoh.kaze.Gadget.$('sidebarImgBg');

			var srcSidebarImgBg = null;
			if (this.flgAlarmImg) {
				srcSidebarImgBg = 'images/aclock0-base_sidebar.png';

			} else {
				srcSidebarImgBg = 'images/aclock' + type + '-base_sidebar.png';
			}
			aaoh.kaze.Element.setImage(sidebarImgBg, srcSidebarImgBg);
		}
	}

	/**
	 * 時計の描画。
	 *
	 * @param {Object} image 描画画像
	 * @param {Number} angle 角度(度)
	 */
	aclock.Main.prototype.
	drawCanvas = function(image, angle) {
		if (
			!image.src
			|| (!aaoh.kaze.Type.isYahoo() && !image.complete)
		) {
			return;
		}

		// ラジアンの算出
		var rad    = angle * Math.PI / 180;
		var transX = (Math.sin(rad) + 1) * this.cvsClock.width / 2;
		var transY = (-1 * Math.cos(rad) + 1) * this.cvsClock.height / 2;
		var pointX = -1 * image.width / 2;
		var pointY = 0;

		this.ctxClock.save();
		this.ctxClock.translate(transX, transY);
		this.ctxClock.rotate(rad);
		this.ctxClock.drawImage(image, pointX, pointY);
		this.ctxClock.restore();
	}

	/**
	 * 時計の描画。
	 *
	 * @param <object> image 描画画像
	 * @param <double> angle 角度(度)
	 */
	aclock.Main.prototype.
	rotateImage = function(image, angle) {
		// ラジアンの算出
		var rad    = angle * Math.PI / 180;
		var pointX = ((Math.sin(rad) + 1) * (this.main.width) / 2)
			- (Math.cos(rad) * image.width / 2);
		var pointY = ((-1 * Math.cos(rad) + 1) * this.main.height / 2)
			- (Math.sin(rad) * image.width / 2);

		if (aaoh.kaze.Type.isSidebar()) {
			image.left     = pointX;
			image.top      = pointY;
			image.rotation = angle;

		} else if (aaoh.kaze.Type.isGoogle()) {
			image.x        = pointX;
			image.y        = pointY;
			image.rotation = angle;
		}
	}

	/**
	 * アラームモードの初期化。
	 */
	aclock.Main.prototype.
	initAlarmMode = function() {
		var alarmMode = null;
		switch (aaoh.sora.App.model.data.alarmMode) {
			// onにする
			case aaoh.sora.App.control.MODE_ALARM_ON:
			case aaoh.sora.App.control.MODE_ALARM_START:
			case aaoh.sora.App.control.MODE_SNOOZE_ON:
			case aaoh.sora.App.control.MODE_SNOOZE_OFF:
			default:
				alarmMode = aaoh.sora.App.control.MODE_ALARM_ON;
				break;

			// offにする
			case aaoh.sora.App.control.MODE_ALARM_OFF:
				alarmMode = aaoh.sora.App.control.MODE_ALARM_OFF;
				break;
		}

		this.setAlarmMode(alarmMode);
	}

	/**
	 * アラームモードの設定。
	 */
	aclock.Main.prototype.
	doAlarmMode = function() {
		var alarmMode = null;
		switch (aaoh.sora.App.model.data.alarmMode) {
			// alarm offにする
			case aaoh.sora.App.control.MODE_ALARM_ON:
			case aaoh.sora.App.control.MODE_SNOOZE_OFF:
			default:
				alarmMode = aaoh.sora.App.control.MODE_ALARM_OFF;
				break;

			// alarm onにする
			case aaoh.sora.App.control.MODE_ALARM_OFF:
				alarmMode = aaoh.sora.App.control.MODE_ALARM_ON;
				break;

			// snooze offまたはalarm offにする
			case aaoh.sora.App.control.MODE_ALARM_START:
				if (aaoh.sora.App.model.data.isSnooze) {
					alarmMode = aaoh.sora.App.control.MODE_SNOOZE_OFF;

				} else {
					alarmMode = aaoh.sora.App.control.MODE_ALARM_OFF;
				}
				break;

			// snooze offにする
			case aaoh.sora.App.control.MODE_SNOOZE_ON:
				alarmMode = aaoh.sora.App.control.MODE_SNOOZE_OFF;
				break;
		}

		this.setAlarmMode(alarmMode);
	}

	/**
	 * アラームモードの設定。
	 *
	 * @param {String} alarmMode アラームモード
	 */
	aclock.Main.prototype.
	setAlarmMode = function(alarmMode) {
		var imgModeUp   = null;
		var imgModeOver = null;
		var imgModeDown = null;
		var tipMode     = null;
		var isDisplay   = false;

		switch (alarmMode) {
			// alarm on
			case aaoh.sora.App.control.MODE_ALARM_ON:
				imgModeUp   = this.srcAlarmOnUp;
				imgModeOver = this.srcAlarmOnOver;
				imgModeDown = this.srcAlarmOnDown;
				tipMode     = this.tipAlarmOn;
				//tipMode     = this.getAlarmTime();

				isDisplay = true;
				break;

			// alarm off
			case aaoh.sora.App.control.MODE_ALARM_OFF:
			default:
				imgModeUp   = this.srcAlarmOffUp;
				imgModeOver = this.srcAlarmOffOver;
				imgModeDown = this.srcAlarmOffDown;
				tipMode     = this.tipAlarmOff;

				isDisplay = false;
				break;

			// alarm start
			case aaoh.sora.App.control.MODE_ALARM_START:
				imgModeUp   = this.srcAlarmStartUp;
				imgModeOver = this.srcAlarmStartOver;
				imgModeDown = this.srcAlarmStartDown;
				tipMode     = this.tipAlarmStart;
				//tipMode     = this.getAlarmTime();

				isDisplay = true;
				break;

			// snooze on
			case aaoh.sora.App.control.MODE_SNOOZE_ON:
				imgModeUp   = this.srcSnoozeOnUp;
				imgModeOver = this.srcSnoozeOnOver;
				imgModeDown = this.srcSnoozeOnDown;
				tipMode     = this.tipSnoozeOn;
				//tipMode     = this.getAlarmTime();

				isDisplay = true;
				break;

			// snooze off
			case aaoh.sora.App.control.MODE_SNOOZE_OFF:
				imgModeUp   = this.srcSnoozeOffUp;
				imgModeOver = this.srcSnoozeOffOver;
				imgModeDown = this.srcSnoozeOffDown;
				tipMode     = this.tipSnoozeOff;

				isDisplay = true;
				break;
		} // switch (alarmMode)

		aaoh.kaze.Element.setBackgroundImage(
			this.btnMode, imgModeUp, imgModeOver, imgModeDown
		);
		aaoh.kaze.Element.setTooltip(this.btnMode, tipMode);

		// データの書込み
		aaoh.sora.App.model.data.alarmMode = alarmMode;
		aaoh.sora.App.model.writeData(
			aaoh.sora.App.control.APP_NAME,
			aaoh.sora.App.control.APP_VERSION
		);

		if (alarmMode != aaoh.sora.App.control.MODE_ALARM_ON) {
			if (this.cvsClock != null) {
				this.setClock();

			} else {
				aaoh.kaze.Element.setDisplay(this.imgAlarmObj, isDisplay);
			}
		}

		// 各アラーム処理
		switch (alarmMode) {
			case aaoh.sora.App.control.MODE_ALARM_ON:
				this.doAlarmOn();
				break;

			case aaoh.sora.App.control.MODE_ALARM_OFF:
			default:
				this.doAlarmOff();

				// 画像の表示
				this.flgAlarmImg = false;
				this.getDrawImages(true);
				break;

			case aaoh.sora.App.control.MODE_ALARM_START:
				this.doAlarmStart();
				break;

			case aaoh.sora.App.control.MODE_SNOOZE_ON:
				this.doSnoozeOn();
				break;

			case aaoh.sora.App.control.MODE_SNOOZE_OFF:
				this.doSnoozeOff();

				// 画像の表示
				this.flgAlarmImg = false;
				this.getDrawImages(true);
				break;
		}

		if (alarmMode == aaoh.sora.App.control.MODE_ALARM_ON) {
			if (this.cvsClock != null) {
				this.setClock();

			} else {
				aaoh.kaze.Element.setDisplay(this.imgAlarmObj, isDisplay);
			}
		}
	}

	/**
	 * アラーム時刻の取得。
	 */
	aclock.Main.prototype.
	getAlarmTime = function() {
		var alarmTime = null;

		var alarm = aaoh.sora.App.model.data.alarm;
		if (alarm != null && alarm != '') {
			alarmTime = alarm.substring(0, alarm.length - 3);

		} else {
			alarmTime = '';
		}

		return alarmTime;
	}

	/**
	 * アラームのOn処理。
	 */
	aclock.Main.prototype.
	doAlarmOn = function() {
		var alarm = aaoh.sora.App.model.data.alarm;
		if (alarm == null || alarm == '') {
			return;
		}

		var alarmList = alarm.split(':');
		if (alarmList.length < 3) {
			return;
		}
		var alarmHour  = alarmList[0];
		var alarmMin   = alarmList[1];
		var alarmSec   = alarmList[2];

		// アラーム角度の設定
		this.alarmAngle
			= ((alarmHour % 12) + alarmMin / 60) * (360 / 12);
		if (this.cvsClock == null) {
			this.rotateImage(this.imgAlarmObj, this.alarmAngle);
		}

		// アラーム時刻の設定
		var alarmDate = new Date()
		alarmDate.setHours(alarmHour);
		alarmDate.setMinutes(alarmMin);
		alarmDate.setSeconds(alarmSec);
		var alarmTime = alarmDate.getTime();

		// 現在時刻の取得
		var date = new Date();
		var time = date.getTime();
		if (alarmTime <= time) {
			alarmTime = alarmTime + 86400000;
		}

		// アラームタイマーの設定
		this.doAlarmOff();
		this.alarmOnTimer.setTimeout(function() {
			aaoh.sora.App.main.setAlarmMode(
				aaoh.sora.App.control.MODE_ALARM_START
			);
		}, alarmTime - date.getTime());
	}

	/**
	 * アラームのOff処理。
	 */
	aclock.Main.prototype.
	doAlarmOff = function() {
		// アラームタイマーのクリア
		this.alarmOnTimer.clearTimeout();
		this.alarmOffTimer.clearTimeout();
		this.snoozeOnTimer.clearInterval();
		this.snoozeOffTimer.clearInterval();

		// 音の停止
		this.soundStop();
	}

	/**
	 * アラームのStart処理。
	 */
	aclock.Main.prototype.
	doAlarmStart = function() {
		// アラームタイマーの設定
		this.alarmOffTimer.setTimeout(function() {
			aaoh.sora.App.main.setAlarmMode(
				aaoh.sora.App.control.MODE_ALARM_OFF
			);
		}, this.ALARM_OFF_TIMEOUT);

		// スヌーズタイマーの設定
		if (aaoh.sora.App.model.data.isSnooze) {
			this.snoozeOnTimer.setInterval(function() {
				aaoh.sora.App.main.snoozeOffTimer.setTimeout(function() {
					aaoh.sora.App.main.setAlarmMode(
						aaoh.sora.App.control.MODE_SNOOZE_OFF
					);
				}, aaoh.sora.App.main.SNOOZE_OFF_TIMEOUT);

				aaoh.sora.App.main.setAlarmMode(
					aaoh.sora.App.control.MODE_SNOOZE_ON
				);
			}, this.SNOOZE_ON_INTERVAL);

			aaoh.sora.App.main.snoozeOffTimer.setTimeout(function() {
				aaoh.sora.App.main.setAlarmMode(
					aaoh.sora.App.control.MODE_SNOOZE_OFF
				);
			}, aaoh.sora.App.main.SNOOZE_OFF_TIMEOUT);
		} // if (aaoh.sora.App.model.data.isSnooze)

		// 音の再生
		this.soundPlay();

		// アラート表示
		this.showAlert();
	}

	/**
	 * スヌーズのOn処理。
	 */
	aclock.Main.prototype.
	doSnoozeOn = function() {
		// 音の再生
		this.soundPlay();

		// アラート表示
		this.showAlert();
	}

	/**
	 * スヌーズのOff処理。
	 */
	aclock.Main.prototype.
	doSnoozeOff = function() {
		// 音の停止
		this.soundStop();
	}

	/**
	 * アラート表示。
	 */
	aclock.Main.prototype.
	showAlert = function() {
		if (!aaoh.sora.App.model.data.isAlert) {
			return;
		}

		var alertMsg = null;
		if (aaoh.sora.App.model.data.isAlertDef) {
			alertMsg = aaoh.sora.App.control.DEFAULT_ALERT_MSG;

		} else {
			alertMsg = aaoh.sora.App.model.data.alertMsg;
		}

		// ポップアップ表示
		aaoh.kaze.Gadget.confirm(alertMsg, function() {
			switch (aaoh.sora.App.model.data.alarmMode) {
				// alarm off
				case aaoh.sora.App.control.MODE_ALARM_OFF:
				default:
					// 処理なし
					break;

				// alarm on
				case aaoh.sora.App.control.MODE_ALARM_ON:
				// alarm start
				case aaoh.sora.App.control.MODE_ALARM_START:
				// snooze on
				case aaoh.sora.App.control.MODE_SNOOZE_ON:
				// snooze off
				case aaoh.sora.App.control.MODE_SNOOZE_OFF:
					var tmpAlarmMode = null;
					if (aaoh.sora.App.model.data.isSnooze) {
						tmpAlarmMode = aaoh.sora.App.control.MODE_SNOOZE_OFF;

					} else {
						tmpAlarmMode = aaoh.sora.App.control.MODE_ALARM_OFF;
					}
					aaoh.sora.App.main.setAlarmMode(tmpAlarmMode);
					break;
			} // switch (alarmMode)
		}, this);
	}

	/**
	 * 音の再生。
	 */
	aclock.Main.prototype.
	soundPlay = function() {
		if (!aaoh.sora.App.model.data.isSound) {
			return;
		}

		var soundFile = null;
		if (aaoh.sora.App.model.data.isSoundDef) {
			soundFile = aaoh.sora.App.control.DEFAULT_SOUND_FILE;

		} else {
			soundFile = aaoh.sora.App.model.data.soundFile;
		}

		// volume
		if (aaoh.sora.App.control.sound.isVolume()) {
			var numSoundVol = aaoh.sora.App.model.data.numSoundVol;
			aaoh.sora.App.control.sound.setVolume(numSoundVol);
		}

		// repeat
		if (aaoh.sora.App.control.sound.isRepeat()) {
			aaoh.sora.App.control.sound.setRepeat(true);

		} else {
			// 固定時間でリピート再生する
			this.alarmRepeatFile = soundFile;
			this.alarmRepeatTimer.setInterval(function() {
				aaoh.sora.App.control.sound.play(
					aaoh.sora.App.main.alarmRepeatFile
				);
			}, aaoh.sora.App.control.DEFAULT_REPEAT_INTERVAL);
		}

		aaoh.sora.App.control.sound.play(soundFile);
	}

	/**
	 * 音の停止。
	 */
	aclock.Main.prototype.
	soundStop = function() {
		if (!aaoh.sora.App.model.data.isSound) {
			return;
		}

		this.alarmRepeatTimer.clearInterval();
		aaoh.sora.App.control.sound.stop();
	}

	/**
	 * アラーム設定の表示。
	 *
	 * @param {Boolean} isDisplay アラーム設定を表示するときにはtrue
	 */
	aclock.Main.prototype.
	showAlarmSet = function(isDisplay) {
		if (isDisplay) {
			var setHour = aaoh.kaze.Gadget.$('setHour');
			var setMin  = aaoh.kaze.Gadget.$('setMin');
			var setSec  = aaoh.kaze.Gadget.$('setSec');

			var alarmHour = '12';
			var alarmMin  = '00';
			var alarmSec  = '00';
			var alarm = aaoh.sora.App.model.data.alarm;
			if (alarm != null && alarm != '') {
				var alarmList = alarm.split(':');

				if (alarmList.length >= 3) {
					alarmHour = alarmList[0];
					alarmMin  = alarmList[1];
					alarmSec  = alarmList[2];
				}
			}

			aaoh.kaze.Element.setValue(setHour, alarmHour);
			aaoh.kaze.Element.setValue(setMin,  alarmMin);
			aaoh.kaze.Element.setValue(setSec,  alarmSec);
		} // if (isDisplay)

		if (this.optFadeinAni != null && this.optFadeoutAni != null) {
			if (isDisplay) {
				var optAlarmSet = aaoh.kaze.Gadget.$('optAlarmSet');
				aaoh.kaze.Element.setDisplay(optAlarmSet, true);
				this.optFadeinAni.start();

			} else {
				this.optFadeoutAni.start();
			}

		} else {
			var optAlarmSet = aaoh.kaze.Gadget.$('optAlarmSet');
			aaoh.kaze.Element.setDisplay(optAlarmSet, isDisplay);
		}

		// 透過PNG対応
		if (aaoh.kaze.Type.isSidebar()) {
			var sidebarOptImgBg = aaoh.kaze.Gadget.$('srcSidebarOptImgBg');
			aaoh.kaze.Element.setDisplay(sidebarOptImgBg, isDisplay);

			if (isDisplay) {
				this.optTimer.setTimeout(function() {
					var sidebarImgBg    = aaoh.kaze.Gadget.$('sidebarImgBg');
					sidebarImgBg.opacity = 100;
				}, 100);
			}
		} // if (aaoh.kaze.Type.isSidebar())
	}

	/**
	 * アラーム設定。
	 */
	aclock.Main.prototype.
	setAlarmSet = function() {
		var setHour = aaoh.kaze.Gadget.$('setHour');
		var setMin  = aaoh.kaze.Gadget.$('setMin');
		var setSec  = aaoh.kaze.Gadget.$('setSec');

		var alarmHour = aaoh.kaze.Element.getValue(setHour);
		var alarmMin  = aaoh.kaze.Element.getValue(setMin);
		var alarmSec  = aaoh.kaze.Element.getValue(setSec);

		// アラーム時刻の設定
		aaoh.sora.App.model.data.alarm
			= alarmHour + ':' + alarmMin + ':' + alarmSec;

		// アラームOnにする
		this.setAlarmMode(aaoh.sora.App.control.MODE_ALARM_ON);
	}

	/**
	 * アラーム設定の開始(時)。
	 *
	 * @param {Boolean} isAdd 値を加算するときにはtrue
	 */
	aclock.Main.prototype.
	addAlarmSetHour = function(isAdd) {
		this.isAlarmSetHourAdd = isAdd;
		this.setAlarmSetHour(isAdd);

		this.alarmSetHourTimer.setInterval(function() {
			aaoh.sora.App.main.setAlarmSetHour(
				aaoh.sora.App.main.isAlarmSetHourAdd
			);
		}, this.ALARM_SET_INTERVAL);
	}

	/**
	 * アラーム設定の停止(時)。
	 */
	aclock.Main.prototype.
	stopAlarmSetHour = function() {
		this.alarmSetHourTimer.clearInterval();
	}

	/**
	 * アラーム設定の開始(分)。
	 *
	 * @param {Boolean} isAdd 値を加算するときにはtrue
	 */
	aclock.Main.prototype.
	addAlarmSetMin = function(isAdd) {
		this.isAlarmSetMinAdd = isAdd;
		this.setAlarmSetMin(isAdd);

		this.alarmSetMinTimer.setInterval(function() {
			aaoh.sora.App.main.setAlarmSetMin(
				aaoh.sora.App.main.isAlarmSetMinAdd
			);
		}, this.ALARM_SET_INTERVAL);
	}

	/**
	 * アラーム設定の停止(分)。
	 */
	aclock.Main.prototype.
	stopAlarmSetMin = function() {
		this.alarmSetMinTimer.clearInterval();
	}

	/**
	 * アラーム設定の開始(秒)。
	 *
	 * @param {Boolean} isAdd 値を加算するときにはtrue
	 */
	aclock.Main.prototype.
	addAlarmSetSec = function(isAdd) {
		this.isAlarmSetSecAdd = isAdd;
		this.setAlarmSetSec(isAdd);

		this.alarmSetSecTimer.setInterval(function() {
			aaoh.sora.App.main.setAlarmSetSec(
				aaoh.sora.App.main.isAlarmSetSecAdd
			);
		}, this.ALARM_SET_INTERVAL);
	}

	/**
	 * アラーム設定の停止(秒)。
	 */
	aclock.Main.prototype.
	stopAlarmSetSec = function() {
		this.alarmSetSecTimer.clearInterval();
	}

	/**
	 * アラーム設定(時)。
	 *
	 * @param {Boolean} isAdd 値を加算するときにはtrue
	 */
	aclock.Main.prototype.
	setAlarmSetHour = function(isAdd) {
		var setHour      = aaoh.kaze.Gadget.$('setHour');
		var alarmHour    = aaoh.kaze.Element.getValue(setHour);
		var numAlarmHour = parseInt(alarmHour, 10);

		// 値の加算
		if (isAdd) {
			numAlarmHour++;

		} else {
			numAlarmHour--;
		}

		if (numAlarmHour < 0) {
			numAlarmHour = 23;

		} else if (numAlarmHour > 23) {
			numAlarmHour = 0;
		}

		var alarmHourValue = numAlarmHour.toString();
		if (alarmHourValue.length <= 1) {
			alarmHourValue = '0' + alarmHourValue;
		}
		aaoh.kaze.Element.setValue(setHour, alarmHourValue);
	}

	/**
	 * アラーム設定(分)。
	 *
	 * @param {Boolean} isAdd 値を加算するときにはtrue
	 */
	aclock.Main.prototype.
	setAlarmSetMin = function(isAdd) {
		var setMin      = aaoh.kaze.Gadget.$('setMin');
		var alarmMin    = aaoh.kaze.Element.getValue(setMin);
		var numAlarmMin = parseInt(alarmMin, 10);

		// 値の加算
		if (isAdd) {
			numAlarmMin++;

		} else {
			numAlarmMin--;
		}

		if (numAlarmMin < 0) {
			numAlarmMin = 59;
			this.setAlarmSetHour(false);

		} else if (numAlarmMin > 59) {
			numAlarmMin = 0;
			this.setAlarmSetHour(true);
		}

		var alarmMinValue = numAlarmMin.toString();
		if (alarmMinValue.length <= 1) {
			alarmMinValue = '0' + alarmMinValue;
		}
		aaoh.kaze.Element.setValue(setMin, alarmMinValue);
	}

	/**
	 * アラーム設定(秒)。
	 *
	 * @param {Boolean} isAdd 値を加算するときにはtrue
	 */
	aclock.Main.prototype.
	setAlarmSetSec = function(isAdd) {
		var setSec      = aaoh.kaze.Gadget.$('setSec');
		var alarmSec    = aaoh.kaze.Element.getValue(setSec);
		var numAlarmSec = parseInt(alarmSec, 10);

		// 値の加算
		if (isAdd) {
			numAlarmSec++;

		} else {
			numAlarmSec--;
		}

		if (numAlarmSec < 0) {
			numAlarmSec = 59;
			this.setAlarmSetMin(false);

		} else if (numAlarmSec > 59) {
			numAlarmSec = 0;
			this.setAlarmSetMin(true);
		}

		var alarmSecValue = numAlarmSec.toString();
		if (alarmSecValue.length <= 1) {
			alarmSecValue = '0' + alarmSecValue;
		}
		aaoh.kaze.Element.setValue(setSec, alarmSecValue);
	}

	/**
	 * アラーム設定(現時刻)。
	 */
	aclock.Main.prototype.
	setAlarmSetNow = function() {
		var date = new Date();
		var hour = date.getHours();
		var min  = date.getMinutes();
		var sec  = date.getSeconds();

		var hourValue = hour.toString();
		var minValue  = min.toString();
		var secValue  = sec.toString();
		if (hourValue.length <= 1) {
			hourValue = '0' + hourValue;
		}
		if (minValue.length <= 1) {
			minValue = '0' + minValue;
		}
		if (secValue.length <= 1) {
			secValue = '0' + secValue;
		}

		var setHour = aaoh.kaze.Gadget.$('setHour');
		var setMin  = aaoh.kaze.Gadget.$('setMin');
		var setSec  = aaoh.kaze.Gadget.$('setSec');
		var flgDisp = false; //aaoh.kaze.Element.isDisplay(setSec);

		aaoh.kaze.Element.setValue(setHour, hourValue);
		aaoh.kaze.Element.setValue(setMin,  minValue);
		if (flgDisp) {
			aaoh.kaze.Element.setValue(setSec,  secValue);
		}
	}

	/**
	 * フォーカス設定。
	 */
	aclock.Main.prototype.
	setFocus = function() {
		// 何もしない
	}

	/**
	 * 表示データの初期化。
	 */
	aclock.Main.prototype.
	initData = function() {
		// デフォルト値の更新
		aaoh.sora.App.control.DEFAULT_ALERT_MSG
			= aaoh.sora.App.control.locale.getString('ALERT_MSG');

		//var flgOnDock = aaoh.sora.App.control.flgOnDock;
		var type      = aaoh.sora.App.model.data.type;

		this.initToolbarData(type);

		//var main    = aaoh.kaze.Gadget.$('main');
		//var imgPin  = aaoh.kaze.Gadget.$('imgPin');
		var srcMain = null;
		var srcPin  = 'images/aclock' + type + '-pin.png';
		if (aaoh.kaze.Type.isSidebar()) {
			var srcMain = 'lib/aaoh.sora.t.png';

		} else {
			var srcMain = 'images/aclock' + type + '-base.png';
		}
		// IE6では入れ子透過PNG対応しない
		aaoh.kaze.Element.setBackgroundImage(this.main, srcMain, false);
		aaoh.kaze.Element.setImage(this.imgPin, srcPin);

		// 透過PNG対応
		if (aaoh.kaze.Type.isSidebar()) {
			var sidebarImgBg = aaoh.kaze.Gadget.$('sidebarImgBg');

			var srcSidebarImgBg = 'images/aclock' + type + '-base_sidebar.png';
			aaoh.kaze.Element.setImage(sidebarImgBg, srcSidebarImgBg);
		}

		this.initClockData(type);
		this.initAlarmData(type);
		this.initAlarmSetData(type);

		if (aaoh.sora.App.control.sound.isSound()) {
			this.alarmRepeatTimer.clearInterval();
			aaoh.sora.App.control.sound.stop();
		}
		this.initAlarmMode();
	}

	/**
	 * 表示データの初期化。
	 *
	 * @param {String} type 表示タイプ
	 */
	aclock.Main.prototype.
	initToolbarData = function(type) {
		//var btnMax    = aaoh.kaze.Gadget.$('btnMax');
		var btnOption = aaoh.kaze.Gadget.$('btnOption');
		var btnClose  = aaoh.kaze.Gadget.$('btnClose');
		//if (btnMax == null || btnOption == null || btnClose == null)
		if (btnOption == null || btnClose == null) {
			return;
		}

		//var srcBtnMaxUp      = null;
		//var srcBtnMaxOver    = null;
		//var srcBtnMaxDown    = null;
		var srcBtnOptionUp   = null;
		var srcBtnOptionOver = null;
		var srcBtnOptionDown = null;
		var srcBtnCloseUp    = null;
		var srcBtnCloseOver  = null;
		var srcBtnCloseDown  = null;
		if (!aaoh.kaze.Type.isGoogle() && !aaoh.kaze.Type.isIE()) {
			//srcBtnMaxUp    = 'images/aclock' + type + '-max.png';
			srcBtnOptionUp = 'images/aclock' + type + '-option.png';
			srcBtnCloseUp  = 'images/aclock' + type + '-close.png';

		} else {
			//srcBtnMaxUp    = 'sub-images/aclock' + type + '-max_up.png';
			srcBtnOptionUp = 'sub-images/aclock' + type + '-option_up.png';
			srcBtnCloseUp  = 'sub-images/aclock' + type + '-close_up.png';
		}
		//srcBtnMaxOver    = 'sub-images/aclock' + type + '-max_over.png';
		//srcBtnMaxDown    = 'sub-images/aclock' + type + '-max_down.png';
		srcBtnOptionOver = 'sub-images/aclock' + type + '-option_over.png';
		srcBtnOptionDown = 'sub-images/aclock' + type + '-option_down.png';
		srcBtnCloseOver  = 'sub-images/aclock' + type + '-close_over.png';
		srcBtnCloseDown  = 'sub-images/aclock' + type + '-close_down.png';

		//aaoh.kaze.Element.setBackgroundImage(
		//	btnMax, srcBtnMaxUp, srcBtnMaxOver, srcBtnMaxDown
		//);
		aaoh.kaze.Element.setBackgroundImage(
			btnOption, srcBtnOptionUp, srcBtnOptionOver, srcBtnOptionDown
		);
		aaoh.kaze.Element.setBackgroundImage(
			btnClose, srcBtnCloseUp, srcBtnCloseOver, srcBtnCloseDown
		);
	}

	/**
	 * 表示データの初期化(時計)。
	 *
	 * @param {String} type 表示タイプ
	 */
	aclock.Main.prototype.
	initClockData = function(type) {
		// 時計画像の設定
		var srcAlarm      = 'images/aclock' + type + '-alarm.png';
		var srcHour       = 'images/aclock' + type + '-hour.png';
		var srcMin        = 'images/aclock' + type + '-min.png';
		var srcSec        = 'images/aclock' + type + '-sec.png';
		var srcAlarmAlarm = 'images/aclock0-alarm.png';
		var srcAlarmHour  = 'images/aclock0-hour.png';
		var srcAlarmMin   = 'images/aclock0-min.png';
		var srcAlarmSec   = 'images/aclock0-sec.png';

		if (aaoh.kaze.Type.isSidebar()) {
			this.imgAlarm   = System.Gadget.path + '/' + srcAlarm;
			this.imgHour    = System.Gadget.path + '/' + srcHour;
			this.imgMin     = System.Gadget.path + '/' + srcMin;
			this.imgSec     = System.Gadget.path + '/' + srcSec;
			this.alarmAlarm = System.Gadget.path + '/' + srcAlarmAlarm;
			this.alarmHour  = System.Gadget.path + '/' + srcAlarmHour;
			this.alarmMin   = System.Gadget.path + '/' + srcAlarmMin;
			this.alarmSec   = System.Gadget.path + '/' + srcAlarmSec;
			aaoh.kaze.Element.setImage(this.imgAlarmObj, this.imgAlarm);
			aaoh.kaze.Element.setImage(this.imgHourObj,  this.imgHour);
			aaoh.kaze.Element.setImage(this.imgMinObj,   this.imgMin);
			aaoh.kaze.Element.setImage(this.imgSecObj,   this.imgSec);

		} else if (aaoh.kaze.Type.isGoogle()) {
			this.imgAlarm   = srcAlarm;
			this.imgHour    = srcHour;
			this.imgMin     = srcMin;
			this.imgSec     = srcSec;
			this.alarmAlarm = srcAlarmAlarm;
			this.alarmHour  = srcAlarmHour;
			this.alarmMin   = srcAlarmMin;
			this.alarmSec   = srcAlarmSec;
			aaoh.kaze.Element.setImage(this.imgAlarmObj, this.imgAlarm);
			aaoh.kaze.Element.setImage(this.imgHourObj,  this.imgHour);
			aaoh.kaze.Element.setImage(this.imgMinObj,   this.imgMin);
			aaoh.kaze.Element.setImage(this.imgSecObj,   this.imgSec);

		} else {
			if (
				(aaoh.kaze.Type.isIGoogle() || aaoh.kaze.Type.isOthers())
				&& aaoh.kaze.Type.isIE()
			) {
				srcAlarm      = 'images/aclock' + type + '-alarm_ie.png';
				srcHour       = 'images/aclock' + type + '-hour_ie.png';
				srcMin        = 'images/aclock' + type + '-min_ie.png';
				srcSec        = 'images/aclock' + type + '-sec_ie.png';
				srcAlarmAlarm = 'images/aclock0-alarm_ie.png';
				srcAlarmHour  = 'images/aclock0-hour_ie.png';
				srcAlarmMin   = 'images/aclock0-min_ie.png';
				srcAlarmSec   = 'images/aclock0-sec_ie.png';
			}

			aaoh.kaze.Element.setImage(this.imgAlarm,   srcAlarm);
			aaoh.kaze.Element.setImage(this.imgHour,    srcHour);
			aaoh.kaze.Element.setImage(this.imgMin,     srcMin);
			aaoh.kaze.Element.setImage(this.imgSec,     srcSec);
			aaoh.kaze.Element.setImage(this.alarmAlarm, srcAlarmAlarm);
			aaoh.kaze.Element.setImage(this.alarmHour,  srcAlarmHour);
			aaoh.kaze.Element.setImage(this.alarmMin,   srcAlarmMin);
			aaoh.kaze.Element.setImage(this.alarmSec,   srcAlarmSec);
		}

		if (this.cvsClock == null) {
			// 秒針画像の表示
			aaoh.kaze.Element.setDisplay(
				this.imgSecObj, aaoh.sora.App.model.data.isDispSec
			);
		}
	}

	/**
	 * 表示データの初期化(アラーム)。
	 *
	 * @param {String} type 表示タイプ
	 */
	aclock.Main.prototype.
	initAlarmData = function(type) {
		// アラーム
		if (!aaoh.kaze.Type.isGoogle() && !aaoh.kaze.Type.isIE()) {
			this.srcAlarmOnUp    = 'images/aclock' + type + '-on.png';
			this.srcAlarmOffUp   = 'images/aclock' + type + '-off.png';
			this.srcAlarmStartUp = 'images/aclock' + type + '-start.png';
			this.srcSnoozeOnUp   = 'images/aclock' + type + '-start.png';
			this.srcSnoozeOffUp  = 'images/aclock' + type + '-suspend.png';

		} else {
			this.srcAlarmOnUp      = 'sub-images/aclock' + type + '-on_up.png';
			this.srcAlarmOnOver    = 'sub-images/aclock' + type + '-on_over.png';
			this.srcAlarmOnDown    = 'sub-images/aclock' + type + '-on_down.png';
			this.srcAlarmOffUp     = 'sub-images/aclock' + type + '-off_up.png';
			this.srcAlarmOffOver   = 'sub-images/aclock' + type + '-off_over.png';
			this.srcAlarmOffDown   = 'sub-images/aclock' + type + '-off_down.png';
			this.srcAlarmStartUp   = 'sub-images/aclock' + type + '-start_up.png';
			this.srcAlarmStartOver = 'sub-images/aclock' + type + '-start_over.png';
			this.srcAlarmStartDown = 'sub-images/aclock' + type + '-start_down.png';
			this.srcSnoozeOnUp     = 'sub-images/aclock' + type + '-start_up.png';
			this.srcSnoozeOnOver   = 'sub-images/aclock' + type + '-start_over.png';
			this.srcSnoozeOnDown   = 'sub-images/aclock' + type + '-start_down.png';
			this.srcSnoozeOffUp    = 'sub-images/aclock' + type + '-suspend_up.png';
			this.srcSnoozeOffOver  = 'sub-images/aclock' + type + '-suspend_over.png';
			this.srcSnoozeOffDown  = 'sub-images/aclock' + type + '-suspend_down.png';
		}

		this.tipAlarmOn    = aaoh.sora.App.control.locale.getString('TIP_ALARM_ON');
		this.tipAlarmOff   = aaoh.sora.App.control.locale.getString('TIP_ALARM_OFF');
		this.tipAlarmStart = aaoh.sora.App.control.locale.getString('TIP_ALARM_START');
		this.tipSnoozeOn   = aaoh.sora.App.control.locale.getString('TIP_SNOOZE_ON');
		this.tipSnoozeOff  = aaoh.sora.App.control.locale.getString('TIP_SNOOZE_OFF');

		var srcSetUp   = null;
		var srcSetOver = null;
		var srcSetDown = null;
		if (!aaoh.kaze.Type.isGoogle() && !aaoh.kaze.Type.isIE()) {
			srcSetUp   = 'images/aclock' + type + '-set.png';

		} else {
			srcSetUp   = 'sub-images/aclock' + type + '-set_up.png';
			srcSetOver = 'sub-images/aclock' + type + '-set_over.png';
			srcSetDown = 'sub-images/aclock' + type + '-set_down.png';
		}
		var tipSet = aaoh.sora.App.control.locale.getString('TIP_ALARM_SET');

		aaoh.kaze.Element.setBackgroundImage(
			this.btnSet, srcSetUp, srcSetOver, srcSetDown
		);
		aaoh.kaze.Element.setTooltip(this.btnSet, tipSet);
	}

	/**
	 * 表示データの初期化(アラーム設定)。
	 *
	 * @param {String} type 表示タイプ
	 */
	aclock.Main.prototype.
	initAlarmSetData = function(type) {
		// アラーム設定
		var alarmSetTtl    = aaoh.kaze.Gadget.$('alarmSetTtl');
		var btnSetHourUp   = aaoh.kaze.Gadget.$('btnSetHourUp');
		var btnSetHourDown = aaoh.kaze.Gadget.$('btnSetHourDown');
		var btnSetMinUp    = aaoh.kaze.Gadget.$('btnSetMinUp');
		var btnSetMinDown  = aaoh.kaze.Gadget.$('btnSetMinDown');
		var btnSetSecUp    = aaoh.kaze.Gadget.$('btnSetSecUp');
		var btnSetSecDown  = aaoh.kaze.Gadget.$('btnSetSecDown');
		var btnSetNow      = aaoh.kaze.Gadget.$('btnSetNow');
		var btnSetOK       = aaoh.kaze.Gadget.$('btnSetOK');
		var btnSetCancel   = aaoh.kaze.Gadget.$('btnSetCancel');
		if (aaoh.kaze.Type.isYahoo()) {
			btnSetOK       = aaoh.kaze.Gadget.$('btnSetOKYahoo');
			btnSetCancel   = aaoh.kaze.Gadget.$('btnSetCancelYahoo');
		}

		var ttlAlarmSetTtl = aaoh.sora.App.control.locale.getString('TIP_ALARM_SET');
		var tipSetHourUp   = aaoh.sora.App.control.locale.getString('TIP_SET_HOUR_UP');
		var tipSetHourDown = aaoh.sora.App.control.locale.getString('TIP_SET_HOUR_DOWN');
		var tipSetMinUp    = aaoh.sora.App.control.locale.getString('TIP_SET_MIN_UP');
		var tipSetMinDown  = aaoh.sora.App.control.locale.getString('TIP_SET_MIN_DOWN');
		var tipSetSecUp    = aaoh.sora.App.control.locale.getString('TIP_SET_SEC_UP');
		var tipSetSecDown  = aaoh.sora.App.control.locale.getString('TIP_SET_SEC_DOWN');
		var tipSetNow      = aaoh.sora.App.control.locale.getString('TIP_SET_NOW');
		var ttlOK          = aaoh.sora.App.control.locale.getString('TTL_OK');
		var ttlCancel      = aaoh.sora.App.control.locale.getString('TTL_CANCEL');

		aaoh.kaze.Element.setValue(alarmSetTtl, ttlAlarmSetTtl);
		aaoh.kaze.Element.setTooltip(btnSetHourUp,   tipSetHourUp);
		aaoh.kaze.Element.setTooltip(btnSetHourDown, tipSetHourDown);
		aaoh.kaze.Element.setTooltip(btnSetMinUp,    tipSetMinUp);
		aaoh.kaze.Element.setTooltip(btnSetMinDown,  tipSetMinDown);
		aaoh.kaze.Element.setTooltip(btnSetSecUp,    tipSetSecUp);
		aaoh.kaze.Element.setTooltip(btnSetSecDown,  tipSetSecDown);
		aaoh.kaze.Element.setTooltip(btnSetNow,      tipSetNow);
		aaoh.kaze.Element.setValue(btnSetOK,     ttlOK);
		aaoh.kaze.Element.setValue(btnSetCancel, ttlCancel);
	}

	/**
	 * イベントの設定。
	 */
	aclock.Main.prototype.
	setEventListener = function() {
		this.setClockEventListener();
		this.setAlarmEventListener();
		this.setAlarmSetEventListener();
	}

	/**
	 * イベントの設定(時計)。
	 */
	aclock.Main.prototype.
	setClockEventListener = function() {
		// 特になし
	}

	/**
	 * イベントの設定(アラーム)。
	 */
	aclock.Main.prototype.
	setAlarmEventListener = function() {
		var btnMode = aaoh.kaze.Gadget.$('btnMode');
		if (btnMode != null) {
			aaoh.kaze.Element.setOnClick(btnMode, function() {
				aaoh.sora.App.main.doAlarmMode();
			});
		}

		var btnSet = aaoh.kaze.Gadget.$('btnSet');
		if (btnSet != null) {
			aaoh.kaze.Element.setOnClick(btnSet, function() {
				aaoh.sora.App.main.showAlarmSet(true);
			});
		}
	}

	/**
	 * イベントの設定(アラーム設定)。
	 */
	aclock.Main.prototype.
	setAlarmSetEventListener = function() {
		var btnSetHourUp = aaoh.kaze.Gadget.$('btnSetHourUp');
		if (btnSetHourUp != null) {
			aaoh.kaze.Element.setOnMouseDown(btnSetHourUp, function() {
				aaoh.sora.App.main.addAlarmSetHour(true);
			});
			aaoh.kaze.Element.setOnMouseUp(btnSetHourUp, function() {
				aaoh.sora.App.main.stopAlarmSetHour();
			});

			if (!aaoh.kaze.Type.isYahoo()) {
				aaoh.kaze.Element.setOnMouseOut(btnSetHourUp, function() {
					aaoh.sora.App.main.stopAlarmSetHour();
				});
			}
		}
		var btnSetHourDown = aaoh.kaze.Gadget.$('btnSetHourDown');
		if (btnSetHourDown != null) {
			aaoh.kaze.Element.setOnMouseDown(btnSetHourDown, function() {
				aaoh.sora.App.main.addAlarmSetHour(false);
			});
			aaoh.kaze.Element.setOnMouseUp(btnSetHourDown, function() {
				aaoh.sora.App.main.stopAlarmSetHour();
			});

			if (!aaoh.kaze.Type.isYahoo()) {
				aaoh.kaze.Element.setOnMouseOut(btnSetHourDown, function() {
					aaoh.sora.App.main.stopAlarmSetHour();
				});
			}
		}

		var btnSetMinUp = aaoh.kaze.Gadget.$('btnSetMinUp');
		if (btnSetMinUp != null) {
			aaoh.kaze.Element.setOnMouseDown(btnSetMinUp, function() {
				aaoh.sora.App.main.addAlarmSetMin(true);
			});
			aaoh.kaze.Element.setOnMouseUp(btnSetMinUp, function() {
				aaoh.sora.App.main.stopAlarmSetMin();
			});

			if (!aaoh.kaze.Type.isYahoo()) {
				aaoh.kaze.Element.setOnMouseOut(btnSetMinUp, function() {
					aaoh.sora.App.main.stopAlarmSetMin();
				});
			}
		}
		var btnSetMinDown = aaoh.kaze.Gadget.$('btnSetMinDown');
		if (btnSetMinDown != null) {
			aaoh.kaze.Element.setOnMouseDown(btnSetMinDown, function() {
				aaoh.sora.App.main.addAlarmSetMin(false);
			});
			aaoh.kaze.Element.setOnMouseUp(btnSetMinDown, function() {
				aaoh.sora.App.main.stopAlarmSetMin();
			});

			if (!aaoh.kaze.Type.isYahoo()) {
				aaoh.kaze.Element.setOnMouseOut(btnSetMinDown, function() {
					aaoh.sora.App.main.stopAlarmSetMin();
				});
			}
		}

		var btnSetSecUp = aaoh.kaze.Gadget.$('btnSetSecUp');
		if (btnSetSecUp != null) {
			aaoh.kaze.Element.setOnMouseDown(btnSetSecUp, function() {
				aaoh.sora.App.main.addAlarmSetSec(true);
			});
			aaoh.kaze.Element.setOnMouseUp(btnSetSecUp, function() {
				aaoh.sora.App.main.stopAlarmSetSec();
			});

			if (!aaoh.kaze.Type.isYahoo()) {
				aaoh.kaze.Element.setOnMouseOut(btnSetSecUp, function() {
					aaoh.sora.App.main.stopAlarmSetSec();
				});
			}
		}
		var btnSetSecDown = aaoh.kaze.Gadget.$('btnSetSecDown');
		if (btnSetSecDown != null) {
			aaoh.kaze.Element.setOnMouseDown(btnSetSecDown, function() {
				aaoh.sora.App.main.addAlarmSetSec(false);
			});
			aaoh.kaze.Element.setOnMouseUp(btnSetSecDown, function() {
				aaoh.sora.App.main.stopAlarmSetSec();
			});

			if (!aaoh.kaze.Type.isYahoo()) {
				aaoh.kaze.Element.setOnMouseOut(btnSetSecDown, function() {
					aaoh.sora.App.main.stopAlarmSetSec();
				});
			}
		}

		var btnSetNow = aaoh.kaze.Gadget.$('btnSetNow');
		if (btnSetNow != null) {
			aaoh.kaze.Element.setOnClick(btnSetNow, function() {
				aaoh.sora.App.main.setAlarmSetNow();
			});
		}
		var btnSetOK = aaoh.kaze.Gadget.$('btnSetOK');
		if (btnSetOK != null) {
			aaoh.kaze.Element.setOnClick(btnSetOK, function() {
				aaoh.sora.App.main.setAlarmSet();
				aaoh.sora.App.main.showAlarmSet(false);
			});
		}
		var btnSetCancel = aaoh.kaze.Gadget.$('btnSetCancel');
		if (btnSetCancel != null) {
			aaoh.kaze.Element.setOnClick(btnSetCancel, function() {
				aaoh.sora.App.main.showAlarmSet(false);
			});
		}
	}

	/**
	 * 初期化処理。
	 */
	aclock.Main.prototype.
	init = function() {
		// 設定情報のデフォルト設定
		if (!aaoh.kaze.Gadget.isConfirm()) {
			aaoh.sora.App.model.data.isAlert = false;
		}
		if (!aaoh.sora.App.control.sound.isSound()) {
			aaoh.sora.App.model.data.isSound = false;
		}

		// 透過PNG対応
		if (aaoh.kaze.Type.isSidebar()) {
			var optAlarmSet = aaoh.kaze.Gadget.$('optAlarmSet');
			var srcOpt      = 'lib/aaoh.sora.t.png';

			aaoh.kaze.Element.setBackgroundImage(optAlarmSet, srcOpt);
		}

		this.setEventListener();
		//this.showAlarmSet(false);

		// 時計開始
		var startTime = new Date().getTime() % 1000;
		this.dispTimer.setTimeout(function() {
			aaoh.sora.App.main.clockTimer.setInterval(function() {
				aaoh.sora.App.main.setClock();
			}, aaoh.sora.App.main.CLOCK_INTERVAL);
		}, startTime);
		this.setClock();
	}
})();
